
/*
 ============================================================================
 Project     : Distance Translocation Algorithm
 Author      : Lucas Angelo Silveira
 Universidade de Brasilia (UnB) - Brazil
 Group of Theory of Computation
 Version     : 1.0
 
 Last Modified On: May 09, 2015.
 ============================================================================
 */


#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>
#include "ComponentIndetification.c"

int * nodeToCompMap;
int Qtd_Tree;
int leaves;
int saveGenoma[20][200];//20 stores genomes containing 200 genes each ones
int flag;
int allGenesInComps=0;
int gene=-1;//saves the value of adjacent element in the identity permutation


//represents a tree
typedef struct{
    int nodeChildren[50];
    char type;//b- black w-white grey g square s
    int root;//is root? 1 is root 0 not is root
    int isleaf;
    int start;//start position of component in one chromosome
    int parent;
    int parei;
    
}Node;

//represents a forest
typedef struct{
    Node * arvore;
    int size_tree;
    int qtd_leaf;
}Conteiner;

typedef struct{
	int p1[2];
    int p2[2];
    int * lista;
    
}listoperation;



char getNodeType(int orientation, int tipo) {
    
    char type;
    if (orientation)
    {
        type='b';
    }
    else
    {
        
        if (tipo == 1 || tipo == 5)
        {
            type = 'w';
        }
        else
        {
            type= 'g';
        }
    }
    return type;
}

Conteiner* generateCompTree(int entrada[],int entrada2[], int siz,int genomeCappedMinus[],int genomeCappedPlus[],componente  COMPONENTS[],int indica){
    
    leaves=0;//set leaves 
    int i,j,w, posicao;
    int size=0;
    int compIndex = 0;
    Qtd_Tree=0;// initialy the value is 0
	int currentnod=-1;
    int square=-1;
    int descarregar=0;

    
    // *************start generateStartAndEndArray *****************
     
    int compStarts[TAMANHO_CAPPEPLUS]; // initiated private variables
    int compEnds[TAMANHO_CAPPEPLUS ];
    if (indica)
    {
    nodeToCompMap=(int *) calloc (CONT, sizeof (int));//cont is global of componentIndetification.c 
    }
    
    if (!indica) {
        for (i=0; i<CONT; i++)
        {
            nodeToCompMap[i]=0;
        }
    }
        
    
    for (i = 0; i < TAMANHO_CAPPEPLUS; i++)
    {
        
        compEnds[i]=-1;
        compStarts[i]=-1;
    }
   

    
    //CONT is a variable of the archive ComponentIndetification.c
    
    for (i = 0; i < CONT; i++)
    {

        compStarts[COMPONENTS[i].startIndex] = i;
        compEnds[COMPONENTS[i].endIndex] = i;
        
    }// fim for
    
    //*********************Build tree about components **************************
    int levelHasComps [CONT]; //if it has comps, go up in tree
    Node * currentNode=malloc ((TAMANHO_CAPPEPLUS) * sizeof (Node));
    Conteiner* compTree=malloc ((TAMANHO_CAPPEPLUS/3) * sizeof (Conteiner));
    
    
    currentnod=descarregar;
    currentNode[descarregar].type='b';//representing current nodo
    currentNode[descarregar].parent=-1;
    currentNode[descarregar].parei=-1;
    currentNode[descarregar].start=-1;
    currentNode[descarregar].root=1;
    currentNode[descarregar].isleaf=0;
    descarregar++;
    
    square=descarregar;
    currentNode[descarregar].type='s';//representing current nodo
    currentNode[descarregar].parent=-1;
    currentNode[descarregar].parei=-1;
    currentNode[descarregar].start=-1;
    currentNode[descarregar].root=1;
    currentNode[descarregar].isleaf=0;
    descarregar++;
    
    for (i=0; i<TAMANHO_CAPPEPLUS; ++i)
    {
        
        if (compStarts[i] > -1 && compEnds[i] == -1)
        {
            levelHasComps[size]=0; //0 is added at the end, if it remains 0 no comp was added until end of level
            size++;
        
        }//end if
        
        
        if (compStarts[i] > -1 && compEnds[i + 1] == -1)
        { //means compLength > 2
           
            if (compEnds[i] == -1 ||levelHasComps[size - 1] == 0)
            {
               
                    square=descarregar;
                    currentNode[descarregar].type='s';//representing current nodo
                    currentNode[descarregar].parent=currentnod;//fala quem e o pai
                    currentNode[descarregar].parei=-1;
                    currentNode[descarregar].start=-1;
                    currentNode[descarregar].root=1;//sera uma raiz?
                    currentNode[descarregar].isleaf=0;
                    
                    posicao=currentNode[currentnod].parei;
                    
                    if (posicao==-1) {
                        posicao=0;
                    }
                    else
                    {
                        posicao++;
                    }
                    currentNode[currentnod].nodeChildren[posicao]=descarregar; //update
                    currentNode[currentnod].parei=posicao; //update
                    currentnod=descarregar;
                    descarregar++;
                 
                    
                
            }//end if
            
            currentnod=descarregar;
            currentNode[descarregar].type= getNodeType(COMPONENTS[compStarts[i]].oriented, COMPONENTS[compStarts[i]].type );
            currentNode[descarregar].parent=square;
            currentNode[descarregar].root=0;
            currentNode[descarregar].parei=-1;
            currentNode[descarregar].start=i;
            currentNode[descarregar].isleaf=0;
            
            posicao=currentNode[square].parei;
            if (posicao==-1) {
                posicao=0;
            }
            else
            {
                posicao++;
            }
            currentNode[square].nodeChildren[posicao]=descarregar; //update
            currentNode[square].parei=posicao; //update
            
            descarregar++;
            levelHasComps[size - 1]= 1; //since comp has been added to level, it is set to 1
            
           
            
            nodeToCompMap[compIndex] = compStarts[i];
            ++compIndex;
            
        
        }//end if
        
        
        else if (compEnds[i] > -1 && compStarts[i] == -1)
        {
            
            
            if (size > 0)
            {
                
                
                if (levelHasComps[size - 1] == 1)
                {//only if current level has a comp, move up in tree
                    
                    currentnod=currentNode[square].parent;
                    if (currentnod!=0 && currentnod!=1)
                    {
                     
                        square=currentNode[currentnod].parent;
                        
                    }
                    
                    else
                    {
                        
                           if (descarregar>2)
                            {
                                compTree[Qtd_Tree].arvore=malloc (descarregar* sizeof (Node));
                                compTree[Qtd_Tree].qtd_leaf=0;
                                for (w=0; w< descarregar;w++)
                                {
                                    
                                    compTree[Qtd_Tree].arvore[w].type= currentNode[w].type;
                                    compTree[Qtd_Tree].arvore[w].parent=currentNode[w].parent;
                                    compTree[Qtd_Tree].arvore[w].start=currentNode[w].start;
                                    compTree[Qtd_Tree].arvore[w].parei=currentNode[w].parei;
                                    compTree[Qtd_Tree].arvore[w].root=currentNode[w].root;
                                    compTree[Qtd_Tree].arvore[w].isleaf=0;
                                    
                                    
                                    
                                    if (currentNode[w].parei>-1)
                                    {
                                        for (j=0; j<=currentNode[w].parei; j++) {
                                            compTree[Qtd_Tree].arvore[w].nodeChildren[j]=currentNode[w].nodeChildren[j];
                                        }//end for
                                    }//end if
                                    
                                    else
                                    {
                                        
                                        if (currentNode[w].type!='s')
                                        {
                                           
                                            compTree[Qtd_Tree].arvore[w].isleaf=1;
                                            compTree[Qtd_Tree].qtd_leaf++;	
                                            leaves++;
                                        }//end if
                                        
                                    }//end else
                                }//end for
                                
                                compTree[Qtd_Tree].size_tree=descarregar;
                                Qtd_Tree++;
                               
                                
                            }
                            
                            
                            descarregar=0;

                            currentnod=descarregar;
                            currentNode[descarregar].type='b';
                            currentNode[descarregar].parent=-1;
                            currentNode[descarregar].parei=-1;
                            currentNode[descarregar].start=-1;
                            currentNode[descarregar].root=1;
                            currentNode[descarregar].isleaf=0;
                            descarregar++;
                            
                            square=descarregar;
                            currentNode[descarregar].type='s';
                            currentNode[descarregar].parent=-1;
                            currentNode[descarregar].parei=-1;
                            currentNode[descarregar].start=-1;
                            currentNode[descarregar].root=1;
                            currentNode[descarregar].isleaf=0;
                            descarregar++;
                        
                    }//end else
                }
                
                 size--;
                
            }//end if siz>0
            
        }//end else if
        
    }//end for
    
     if (descarregar>2)
    {
        
        compTree[Qtd_Tree].arvore=malloc (descarregar * sizeof (Node));
        compTree[Qtd_Tree].qtd_leaf=0;
        for (w=0; w< descarregar;w++)
        {
            
            compTree[Qtd_Tree].arvore[w].type= currentNode[w].type;
            compTree[Qtd_Tree].arvore[w].parent=currentNode[w].parent;//fala quem e o pai
            compTree[Qtd_Tree].arvore[w].start=currentNode[w].start;//fala quem e o pai
            compTree[Qtd_Tree].arvore[w].parei=currentNode[w].parei;
            compTree[Qtd_Tree].arvore[w].root=currentNode[w].root;//sera uma raiz?
            compTree[Qtd_Tree].arvore[w].isleaf=0;
            
            
            if (currentNode[w].parei>-1)
            {
                
                for (j=0; j<=currentNode[w].parei; j++) {
                    compTree[Qtd_Tree].arvore[w].nodeChildren[j]=currentNode[w].nodeChildren[j];
                }//end for
            }//end if
            
            else
            {
            
                if (currentNode[w].type!='s')
                {
                    compTree[Qtd_Tree].arvore[w].isleaf=1;
                    compTree[Qtd_Tree].qtd_leaf++;
                    leaves++;
                }//end if
            }//end else
            
        }//end for
        
        compTree[Qtd_Tree].size_tree=descarregar;
        Qtd_Tree++;
    }
    
    return compTree;
    
    
    
}//end generateCompTree

/**
     * Generates a mapping for the genes of genome A to their chromosome number.
     * It has to be updated, because the former chrom map belongs to the genome
     * sorted from 1 to N and now genome A's genes are sorted according to genome B!
     * I.e. gene 9 may now be gene 6 and if 6 and 9 are on different chromosomes
     * the old mapping still returns the chrom number of the former 6 for the current gene 6!
     * @param entrada Genoma in format string e o your size
     * @return the new chromosome mapping for the genes of A
     */
void genNewChromMap(int entrada[],int siz,int * newChromMap) {
        int i,j;
        int chromNb = 1;
        for (i = 0; i < siz; ++i)
        { 
         	newChromMap[i]=0;	
        }
        int *a= status_A(entrada,siz);
        for (i = 1; i < qtd_cromossomo; ++i)
        {
            for (j = 0; j < a[i]; ++j)
            {   
                int geneL = GENOMA_A[i][j];
                newChromMap[abs(geneL)] = chromNb;
            }
            ++chromNb;
        }//end for 
         
        free(a);
    
    }


 void cromossomo(int genes[],int siz, int isCircular){

		int length = flag;
        length++;
		int i;
		for ( i = 0; i < siz; i++) {
			GENOMA_A[length][i]=genes[i];
		}
		
		GENOMA_A[length][siz]=isCircular;
        flag=length;//update in flag
        if(siz+1<200)
		   GENOMA_A[length][siz+1]=99999;        
        else
           printf("**************Alert over the space for the new genome***************\n\n\n");
}

//makes the formation of new genome after one translocation
void generateGenome(int adjacencyArray[],int siz){
   
    int m=0;
    flag=-1;
    int currentChrom [qtd_genes];
    int current=0;
    int * visited = (int *) calloc (siz, sizeof (int));
    int j;
    for (j = 1; j < siz; ++j)
    {
        if (visited[j] == 0) {
            // so we start with the chromosome containing gene 1 = 0,1
            int currentAdj1 = j;
            int currentAdj2 = adjacencyArray[currentAdj1]; // j is first element, currentAdj scnd
            int geneToAdd = (currentAdj1 + 1) / 2; // (1h, 2t) --> add 1 & in while schleife 2 before 1
            if (currentAdj1 % 2 == 0) { // if tail gene is negative
                geneToAdd *= -1;
            }
            
            currentChrom[current]=geneToAdd;
            current++;
            visited[currentAdj1] = 1;
            
            // first direction 1t, extend to left
            while (((currentAdj2 % 2 == 1 && !visited[currentAdj2 + 1]) || (currentAdj2 % 2 == 0 && !visited[currentAdj2 - 1]))
                   && currentAdj1 != currentAdj2) { // as long as no circle or telomere
                geneToAdd = (currentAdj2 + 1) / 2;
                if (currentAdj2 % 2 == 1) { // if head gene is negative
                    geneToAdd *= -1;
                }
                
                m=current-1;
                for (; m>=0; m--) {//qtd_genes is global of validate_input.c
                      currentChrom[m+1]=currentChrom[m];
                }
                
                currentChrom[0]=geneToAdd;
                current++;
                visited[currentAdj2] = 1;
                
                // get values of next adjacency
                if (currentAdj2 % 2 == 0) { // currently tail was reviewed, f.e. (1t,3h) -> j=3t
                    currentAdj1 = --currentAdj2;
                } else {
                    currentAdj1 = ++currentAdj2;
                }
                currentAdj2 = adjacencyArray[currentAdj1]; // f.e. currentAdj = list[3t] = 5h
                visited[currentAdj1] = 1;
            }
            
            if (currentAdj1 != currentAdj2
                && ((currentAdj2 % 2 == 1 && visited[currentAdj2 + 1]) || (currentAdj2 % 2 == 0 && visited[currentAdj2 - 1]))) {
                //if circle chrom is complete
                
                cromossomo(currentChrom,current,1);
                current=0;
                visited[currentAdj1] = 1;
                visited[currentAdj2] = 1;
            }
            else
            {
                
                if (currentAdj1 == currentAdj2)
                {
                    visited[currentAdj1] = 1;
                    if (j % 2 == 0) { // currently tail was reviewed, f.e. (3t) -> currentAdj1=3h
                        currentAdj1 = j - 1;
                    }
                    else {
                        currentAdj1 = j + 1;
                    }
                }
                else
                {
                    if (currentAdj2 % 2 == 0)
                    { // currently tail was reviewed, f.e. (3t) -> currentAdj1=3h
                        currentAdj1 = --currentAdj2;
                    }
                    else
                    {
                        currentAdj1 = ++currentAdj2;
                    } 
                }
                
                currentAdj2 = adjacencyArray[currentAdj1];
                while (currentAdj1 != currentAdj2) {
                    geneToAdd = (currentAdj2 + 1) / 2;
                    if (currentAdj2 % 2 == 0)
                    { // if tail gene is negative
                        geneToAdd *= -1;
                    }
                   
                    currentChrom[current]=geneToAdd;
                    current++;
                    visited[currentAdj1] = 1;
                    visited[currentAdj2] = 1;
                    
                    // get values of next adjacency
                    if (currentAdj2 % 2 == 0) {
                        currentAdj1 = --currentAdj2;
                    } else {
                        currentAdj1 = ++currentAdj2;
                    }
                    currentAdj2 = adjacencyArray[currentAdj1]; // f.e. currentAdj = list[3h] = 5t
                }
		
                 cromossomo(currentChrom,current,0);
                current=0;
                visited[currentAdj1] = 1;
            }
            m=0;
            for(;m<qtd_genes;m++)
                currentChrom[m]=0;
            current=0;
        }
    } //end for
    
 }//end function
	

int * generateGeneInCompArray( componente components[], int plusCappedGnom[], int numberOfGenes) {
   int * geneInCompArray =(int *) calloc (numberOfGenes + 1, sizeof (int));
   int counter = 0;
   int start,end,i,j;
   int compBorders[2];
    for ( i = 0; i < CONT ; ++i) {
       
        if (components[i].startIndex < components[i].endIndex)
        {
                compBorders[0]=components[i].startIndex;
                compBorders[1]=components[i].endIndex;
        }
        else
        {
            compBorders[0]=components[i].endIndex;
            compBorders[1]=components[i].startIndex;
        }
        start=compBorders[0];
        end = compBorders[1];
        if (end - start >= 2) {
            for ( j = start; j <= end; ++j) {
                if (geneInCompArray[abs(plusCappedGnom[j])] == 0) {
                    ++counter;
                }
                geneInCompArray[abs(plusCappedGnom[j])] = 1;
            }
        }
    }
    if (counter == numberOfGenes)
    {
        allGenesInComps = 1;
    }
    else
    {
        allGenesInComps = 0;
    }
    return geneInCompArray;
}


int * generateGeneAtCompBorderArray(componente components[], int plusCappedGnom[], int numberOfGenes) {
   int * geneAtCompBorderArray = (int *) calloc (numberOfGenes + 1, sizeof (int));
   int compBorders[2];
   int start,i;
   int end;
   for ( i = 0; i < CONT ; ++i) {
       if (components[i].startIndex < components[i].endIndex)
       {
           compBorders[0]=components[i].startIndex;
           compBorders[1]=components[i].endIndex;
       }
       else
       {
           compBorders[0]=components[i].endIndex;
           compBorders[1]=components[i].startIndex;
       }
       start=compBorders[0];
       end = compBorders[1];
        if (end - start >= 2) {
            geneAtCompBorderArray[abs(plusCappedGnom[start])] = 1;
            geneAtCompBorderArray[abs(plusCappedGnom[end])] = -1;
        }
        
    }
    return geneAtCompBorderArray;
}


int * generatePosDepthArray(int plusCappedGnom[], componente components[],int numberOfGenes) {
    
    int* posDepthArray =  (int *) calloc (numberOfGenes + 1, sizeof (int));
    int iComp;
    int start;
    int stop,i;    
    for (i = 0; i < CONT; ++i)
    {
    
        iComp = nodeToCompMap[i];
        if (iComp > 0)
        {
            start = components[iComp].startIndex;
            stop = components[iComp].endIndex;
            int val,j;
            for (j = start; j <= stop; ++j)
            {
                val = abs(plusCappedGnom[j]);
                if (val > 0 && val <= numberOfGenes) {
                    ++posDepthArray[val];
                }
            }//end for
        }//end if
    }//end for
    
    return posDepthArray;
}


int numberLeaves(Conteiner compTree[], int siz){
    int i,j;
    int cont=0;
    for (i=0; i<Qtd_Tree; i++)
    {
        for (j=0; j<compTree[i].size_tree; j++)
        {
            
            if (compTree[i].arvore[j].isleaf==1)
            {
                cont++;
            }//end if
            
        }//end for
    }//end for

    return cont;
}
/**
 * Calculates the extremity number used in the adjacency array from the gene number.
 * @param geneExt gene index already *2
 * @param fstExtremity(variable representation value boolean) if it is the left extremity of an adjacency
 * @return the correct extremity
 */
 int  getExtremity1(int geneExt, int fstExtremity) {
     
    if (geneExt < 0 && fstExtremity) {
        return (geneExt * -1) - 1;
    }
    else if (geneExt < 0 && !fstExtremity) {
        return -geneExt;
    }
    else if (geneExt > 0 && !fstExtremity) {
        return geneExt - 1;
    }
    return geneExt;
}//end function

 void generateInvolvedExtremities( int start, int plusCappedGnom[], int chromMap[],int geneInCompArray[],int geneAtCompBorderArray[], int posDepthArray[], int entrada[], int siz,int involvedExtremities[])
{

    int * status= status_A( entrada,siz);
    involvedExtremities[0] = getExtremity1(plusCappedGnom[start] * 2, 1);
    involvedExtremities[1] = getExtremity1(plusCappedGnom[start + 1] * 2, 0);
    int chromNb = chromMap[abs(plusCappedGnom[start])]; //chrom number can't change during while loop
    int doesntFit = 1;
    int cutChromNb = 0;
    int i ;
    int * chrom =copiar_cromossomo(cutChromNb, status[cutChromNb], 1);//referente ao arquivo adjacentygraph.c
    i=0;
    
    if (allGenesInComps)//variavel global
    {
        if (cutChromNb < qtd_cromossomo - 1 && chromNb == cutChromNb)
        {
            free(chrom);
            ++cutChromNb;
            chrom =copiar_cromossomo(cutChromNb, status[cutChromNb],1);
        }//end if
        involvedExtremities[2] = getExtremity1(chrom[0] * 2, 1);
        involvedExtremities[3] = getExtremity1(chrom[1] * 2, 0);
    }//end if
    
    else
    {
        while (doesntFit)
        {
            if (cutChromNb < qtd_cromossomo - 1 && (chromNb == cutChromNb || i >= status[cutChromNb] - 2))
            {
                ++cutChromNb; //must always work as there cant be only 1 chrom
                if (cutChromNb == chromNb)
                {
                    ++cutChromNb;
                }
                free(chrom);
                chrom= copiar_cromossomo(cutChromNb, status[cutChromNb],1);
                i = 0;
            }//end if
            int geneL = chrom[i];
            int geneAbs;
            while ((geneInCompArray[geneAbs = abs(geneL)] && i < status[cutChromNb] - 2) && 
		   (( (geneAtCompBorderArray[geneAbs] == 1 && i == 0) ||
		      (geneAtCompBorderArray[geneAbs] == -1 && i == status[cutChromNb] - 1) || //a comp border & between
		      ( ((geneAtCompBorderArray[geneAbs] == 1 && i == 0) ||
			 (geneAtCompBorderArray[geneAbs] == -1 && i == status[cutChromNb] - 1))
			  && posDepthArray[geneAbs] > 1) ) || // 2 comps at top level in tree there can be a cut.
                       geneAtCompBorderArray[geneAbs] == 0)) { //means comp is not directly below root of tree = at least in scnd layer
                       
                       geneL = chrom[++i];
                   }
            if (i == status[cutChromNb] - 1) {
                doesntFit = 1;
            } else {
                involvedExtremities[2] = getExtremity1(geneL * 2, 1);
                involvedExtremities[3] = getExtremity1(chrom[i + 1] * 2, 0);
                doesntFit = 0;
            }
            
        }//while
        
    }//else
    
    
    if ( involvedExtremities[2]==0 || involvedExtremities[3]==0)
    {
        
        cutChromNb = 0;
        chromNb = chromMap[abs(plusCappedGnom[start])];
        chrom =copiar_cromossomo(cutChromNb, status[cutChromNb], 1);//referente ao arquivo adjacentygraph.c
        if (cutChromNb < qtd_cromossomo - 1 && chromNb == cutChromNb)
        {
            free(chrom);
            ++cutChromNb;
            chrom =copiar_cromossomo(cutChromNb, status[cutChromNb],1);
        }//end if
        involvedExtremities[2] = getExtremity1(chrom[0] * 2, 1);
        involvedExtremities[3] = getExtremity1(chrom[1] * 2, 0);
    }
    
    free(status);
    
   
    
}//end generateInvolvedExtremities


/**
 * Tests if the components are on different chromosomes or not.
 * @return 1if they are on different chroms, 0 otherwise
 */
int  testCompsOnDiffChroms( int compMap[],int size_compMap,componente components[], int size_comp) {
    int fstChromNb = -1;
    int scndChromNb = -1;
    int i;
    int largeComp = 0;
    i = 1;
    while (i < size_compMap && scndChromNb == -1) {
 
        largeComp = abs(components[i].endIndex - components[i].startIndex);
        if (largeComp >= 2)
        {
            
            if (fstChromNb == -1)
            {
                fstChromNb = compMap[i];
            }
            else if (fstChromNb != compMap[i])
            {
                scndChromNb = compMap[i];
            }
        }
        ++i;
    }
    if (fstChromNb != scndChromNb && fstChromNb != -1 && scndChromNb != -1 && size_compMap > 1) {
        return 1;
    }
    return 0;
    
}//end components



/**
 * Generates an integer array containing a mapping for each component
 * index in the component array to the chromosome number the component is
 * located on.
 * @return the component to chromosome mapping array
 */
void generateCompMap(int chromMap[], componente components[],int tamanho, int plusCappedGnom[], int * compMap) {
    int i;
    for (i=0; i<tamanho; i++) {
        compMap[i]=0;
    }
    for (i=0; i < tamanho; ++i) {
        int geneL = plusCappedGnom[components[i].startIndex];
        compMap[i] = chromMap[abs(geneL)];
    }
    

}


int calcTransDist(int numbercicles, int qtdgenes, int qtdcromossomo, int leaves,int qtdtree ){
    int t;
    
    if (leaves%2==0 && qtdtree==1)
        t= leaves+2;
    
    else if(leaves%2==1)
        t=leaves+1;
    else
        t=leaves;
return qtdgenes - qtdcromossomo - numbercicles + t;
    
}

/**
 * Assigns the four involved extremities for an operation in the adjacency graph.
 
 * @return the modified adjacency graph array
 */
int * assignInvolvedExtr( int involvExtremities[], int adjArray1[], int  standard) {
    if (standard)
    {
        adjArray1[involvExtremities[0]] = involvExtremities[3];
        adjArray1[involvExtremities[3]] = involvExtremities[0];
        adjArray1[involvExtremities[1]] = involvExtremities[2];
        adjArray1[involvExtremities[2]] = involvExtremities[1];
    }
    
    else
    {
        adjArray1[involvExtremities[0]] = involvExtremities[2];
        adjArray1[involvExtremities[2]] = involvExtremities[0];
        adjArray1[involvExtremities[1]] = involvExtremities[3];
        adjArray1[involvExtremities[3]] = involvExtremities[1];
    }
    
    return adjArray1;
}

//Returns the mapping of each leaf to its index of the associated component
int * getLeafToIndexMap(Conteiner compTree[], int siz, int folhas){
    
    int * leafToIndexMap = (int *) calloc (folhas, sizeof (int));

    int i,j;
    int cont=-1;
    
    for (i=0; i<Qtd_Tree; i++) {
     
        for (j=0; j<compTree[i].size_tree; j++)
        {
            
            if (compTree[i].arvore[j].isleaf==1)
            {
                cont++;
                leafToIndexMap[cont]=i;

            }//end if
            
        }//end for
         
    }//end for
    return leafToIndexMap;

}

//returns which chromosome the gene belongs
int verifica_crhom(int posgene, int entrada[],int siz){
    int i;
    int cont=0;
    for (i=0; i<siz; i++)
    {
        if (entrada[i]==0)
        {
            cont++;
        }
        if(i==posgene)
            break;
    }

    return cont;
}

//returns one of the big tree leaf
int leaf_bigTree(Conteiner compTree[],int siz,int nodeIBigTree, int leafToIndexMap[],int siz2)
{
    int i;
    int retorno;
    for (i=0; i<siz2; i++)
    {
        if (leafToIndexMap[i]==nodeIBigTree) {
            if (leafToIndexMap[i]==0) {
                printf("******************Error***************************");
            }
            else
                break;
        }
    }//end for
    
    retorno=leafToIndexMap[i];
    if (compTree[nodeIBigTree].size_tree>2) {
        i=i+2;
        if (leafToIndexMap[i+1]==nodeIBigTree)
        {
            retorno=leafToIndexMap[i];
        
        
        }
    }
    return retorno;

}

/**
 * Checks if there exists a component longer than 2 elements.
 * @return 1 if there is a component longer than 2 elements (at least 3 elements)
 */
int checkCompLength(componente components[],int siz) {
    int i;
    for (i = 0; i < siz; ++i) {
        if (abs(components[i].endIndex - components[i].startIndex) >= 2) {
            return 1;
        }
    }
    return 0;
}


void clona_genoma(){
    int i=0;
    int j=0;
    while (j<=flag) {
        
        
        while (GENOMA_A[j][i]!=99999) {
            saveGenoma[j][i]=GENOMA_A[j][i];
            i++;
        }
       
         saveGenoma[j][i]=GENOMA_A[j][i];
        j++;
        i=0;
        
    }


}
//recovery genoma by suport genoma
void rec_genoma(){

    int i=0;
    int j=0;
    while (j<=flag) {
        
        
        
        while (saveGenoma[j][i]!=99999)
        {
            
            GENOMA_A[j][i]=saveGenoma[j][i];
            i++;
        }//end while interno
      
        GENOMA_A[j][i]=saveGenoma[j][i];
        j++;
        i=0;
    }//end while externo


}

int * SavePlusCapped( int genomeCappedPlus[], int SavePlusCapped[]){
    int i;
    for (i=0; i<TAMANHO_CAPPEPLUS; i++) {
        SavePlusCapped[i]=genomeCappedPlus[i];
    }
    return SavePlusCapped;
}

int * SaveMinCapped( int genomeCappedMinus[], int saveMinCapped[]){
    int i;
    for (i=0; i<TAMANHO_CAPPEPLUS; i++) {
        saveMinCapped[i]=genomeCappedMinus[i];
    }
    return saveMinCapped;
}
int * reconstruirentrada(int newentrada[], int siz){
   int i=0;
   int j=0;
   int cont=0;
     while (j<=flag) {
        
        
        while (GENOMA_A[j][i]!=99999) {
            if (GENOMA_A[j][i+1]!=99999)
            {
                
                newentrada[cont]=GENOMA_A[j][i];
                cont++;
            }
            else
            {
                if(cont<siz-1)
                {
                    newentrada[cont]=GENOMA_A[j][i]=0;
                    cont++;
                }
            }
            i++;
        }//end while interno
        j++;
        i=0;
        
    }//end while externo
    return newentrada;
}

//makes mapping returning the indexes to each component leaf in the big tree
int * TreeIndexMap(Conteiner compTree[],int siz, int folhas){
    int *treeIndexMap=(int *) calloc (folhas, sizeof (int));
    int i,j;
    int cont=0;
    for (i=0; i<Qtd_Tree; i++) {
        for (j=0; j<compTree[i].size_tree; j++)
        {
            if (compTree[i].arvore[j].isleaf==1)
            {
                 treeIndexMap[cont]=i;
            }//end if
            
        }//end for
        cont++;
    }//end for
   
    return treeIndexMap;
}

/**
 * Utility method returning the index of the first leaf of a tree in the component array.
 * @return the index of the first leaf in the component array
 */
 int getFstLeafOfTree(int treeIndex, int leafToIndexMap[],int siz) {

    int i = 0;
    int fstLeaf = 0;
     
     
     while (fstLeaf < treeIndex) {
         fstLeaf=leafToIndexMap[++i];
     }
     return fstLeaf;
}

/**
 * Checks for two extremities if a translocation at this position was already carried out
 * and identified as improper.
 * @return 1 if the translocation would be improper
 */
int checkImproper(int ex, int startEx, int adjG1[],int improperAdjs[],int siz) {//improperAdjs representa um arranjo de pares (i, i+1)
    int i;
    for ( i = 0; i < siz; i=i+2) {
        int fst = improperAdjs[i];
        int scnd = improperAdjs[i+1];
        int t=i;
        t=t+2;
        
        int thrd = improperAdjs[t];
        int fourth = improperAdjs[t+1];
        if (ex == fst || ex == scnd || ex == thrd || ex == fourth)
        {
            if (startEx == fst || startEx == scnd || startEx == thrd || startEx == fourth) {
                int ex3 = adjG1[ex];
                
                if (ex3 == fst || ex3 == scnd || ex3 == thrd || ex3 == fourth)
                {
                    int ex4 = adjG1[ex];
                    if (ex4 == fst || ex4 == scnd || ex4 == thrd || ex4 == fourth)
                    {
                        return 1;
                    }
                }
            }
        }//end if
        i=i+2;
    }//end for
    return 0;
}


/**
 * Checks if adjacent genes are on same chromosome or not. It is returned negative, if the tail of the
 * previous gene is wanted and positive if the head of the concurrent gene is wanted.
 * @return 1 if both are on same chrom
 */
int  ChromCheck(int plusCappedGnom[], int newChromMap[], int start, int nbGenes) {
    int curGene = abs(plusCappedGnom[start]);
    int chromCheck ;
    if (curGene > nbGenes || curGene == 0) {
        chromCheck=1;
    }
    else
        chromCheck=0;
    
    if (!chromCheck)
    {
        if (getExtremity1(plusCappedGnom[start] * 2, 1) % 2 == 1) {
            
	  (chromCheck = newChromMap[curGene] == newChromMap[curGene - 1]
	   || ((plusCappedGnom[start] < 0 && plusCappedGnom[start + 1] > nbGenes) //it is true, if this is a chromosome border
	       || (plusCappedGnom[start] > 0 && plusCappedGnom[start - 1] == 0))); //because we want to skip it!
            gene = -1 * (curGene - 1);
        }
        
        else
        {
            chromCheck =  newChromMap[curGene] == newChromMap[curGene + 1]
	      || ((plusCappedGnom[start] < 0 && plusCappedGnom[start - 1] == 0) //it is true, if this is a chromosome border
		  || (plusCappedGnom[start] > 0 && plusCappedGnom[start + 1] > nbGenes)); //because we want to skip it!
            gene = curGene + 1;
        }
        if (chromCheck)
        {
            curGene = abs(plusCappedGnom[start + 1]);
            chromCheck = curGene > nbGenes || curGene == 0;
            if (!chromCheck)
            {
                if (getExtremity1(plusCappedGnom[start + 1] * 2, 0) % 2 == 1)
                {
                    chromCheck = newChromMap[curGene] == newChromMap[curGene - 1]; //because we want to skip it!
                    gene = curGene - 1;
                }
                else
                {
                    chromCheck = newChromMap[curGene] == newChromMap[curGene + 1]; //because we want to skip it!
                    gene = -1 * (curGene + 1);
                }
            }
        }
    }//end if
    return chromCheck;
}



/**
 * Finds gene in genome.
 * @param plusCappedGnom
 * @return index of geneIndex
 */
int *genScndCut(int plusCappedGnom[], int adjacency[]) {
    int extremity = -1;
    int i;
    for (i = 0; i < TAMANHO_CAPPEPLUS; ++i) {
        if (abs(plusCappedGnom[i]) == abs(gene))
        {
            if (gene < 0)
            { //get tail of this gene
                extremity = -1 * gene * 2;
            }
            else
            { //get head
                extremity = gene * 2 - 1;
            }
            if ((plusCappedGnom[i] < 0 && gene < 0) || (plusCappedGnom[i] > 0 && gene > 0) ) { //check orientation of gene in genome
              
               if( i>0 && plusCappedGnom[i-1]==0)   
	       {
		    adjacency[0] = extremity+1;
                    adjacency[1] = getExtremity1(plusCappedGnom[i + 1] * 2, 0); // cut right of gene;
                 
               }  
               else
                {
                 adjacency[0] = getExtremity1(plusCappedGnom[i - 1] * 2, 1); // cut left of gene
                 adjacency[1] = extremity;
                 
                }
            
            }
            else
            {
		adjacency[0] = extremity;
                adjacency[1] = getExtremity1(plusCappedGnom[i + 1] * 2, 0); // cut right of gene;
            }
            break;
        }
    }
    return adjacency;
}

int * clonar_adjG1(int adjArray1[], int adjG1[], int siz){
  
   int i;
   for(i=0;i<siz;i++)
	adjArray1[i]=adjG1[i];		

return adjArray1;
}


int * recoveryPlusCapped(int savePlusCapped[], int genomeCappedPlus[], int siz){
	int i;
	for(i=0;i<siz;i++)
	{
		genomeCappedPlus[i]=savePlusCapped[i];


	}
return genomeCappedPlus;
}



int * recoveryMinCapped(int saveMinCapped[],int genomeCappedMinus[], int siz){
	int i;
	for(i=0;i<siz;i++)
	{
		genomeCappedMinus[i]=saveMinCapped[i];


	}
return genomeCappedMinus;
}

int distance(int entrada[],int entrada2[], int siz){
   int t;
   
    identifyComponents( entrada,entrada2, siz,1);//carrega funcoes para calculo de indentificacao de componentes
    
    
    int *genomeCappedMinus= cappingM(entrada, siz);
    int *genomeCappedPlus= cappingP(entrada,siz);
    int nbegnes=qtd_genes;
    componente * COMPONENTS=compIdentificationPhase12(nbegnes,entrada, entrada2, siz);
     generateCompTree(entrada, entrada2, siz,genomeCappedMinus,genomeCappedPlus,COMPONENTS,1);
    
    if (leaves%2==0 && Qtd_Tree==1)
        t= leaves+2;
    
    else if(leaves%2==1)
        t=leaves+1;
    else
        t=leaves;
    
    

    return nbegnes - qtd_cromossomo - numberOfCycles + t;

}//end function 


void grava( listoperation operationList[], int n, int siz, int dist){
    char *nombre_archivo = "ArqGrav.txt"; //archivo "i"
    FILE *filePointer;
    int i,j;
    /*Guardar Permutacao no arquivo*/
    if ((filePointer = fopen(nombre_archivo,"w")) == NULL){
        printf("Output file could not be opened\n");
    }
    else
    {
	fprintf(filePointer,"********************************\n");
        fprintf(filePointer,"A Distance of Translocation is: %d\n",dist);
	fprintf(filePointer,"********************************\n");
        fprintf(filePointer,"Input\n");
        for(i=0; i<=n; i++)
       {


	  for(j=0;j<siz;j++)
         {  
	   		
           if(j==0)
	   {
	      fprintf(filePointer,"(%d,",operationList[i].lista[j]); 
           }	
           else if(j+1==siz)
          {
	     fprintf(filePointer,"%d)",operationList[i].lista[j]);
          } 
          else if(operationList[i].lista[j]==0)
	  {
        	fprintf(filePointer,") (");
          }
	  else if(operationList[i].lista[j+1]==0)
          {
		fprintf(filePointer,"%d",operationList[i].lista[j]);
          }	
          else
          {
		fprintf(filePointer,"%d,",operationList[i].lista[j]);
          }
       }	
      fprintf(filePointer,"\n");
      fprintf(filePointer,"\n");	           
     }
	//fclose(filePointer);
   }
   
    
    
}//fim da funcao


int unica_translocacao(int entrada[], int siz)
{
    int i,j;
    int mesmo_cromo=0;
    int cromi=0;
    int cromj=0;
    int captura=-1;
    
    for (i=1; i<siz-1; i++)
    {
        //evitar os extremos
        if (i!=siz-1 && entrada[i+1]!=0 && entrada[i-1]!=0)
        {
            
            
            if (entrada[i]==0) {
                cromi++;
            }
            
            
            for (j=1; j< siz-1; j++)
            {
                
                if (entrada[j]==0)
                {
                    cromj++;
                }
                
                if ((entrada[i]!=entrada[j]) && j!=siz-1 && entrada[j+1]!=0 && entrada[j-1]!=0)
                {
                    
                                       
                    
                    if (abs(entrada[i])== abs(entrada[j]+1) || abs(entrada[i])== abs(entrada[j]-1))
                    {
                        if (cromj!=cromi)
                        {

                            if (captura==-1) {
                                captura=i;
                            }
                            
                            mesmo_cromo++;
                        }
                        
                    }//end if
                }//end if
                
            }//end for
          
            cromj=0;
            
            
        }//end if
    }//end for

    if ((mesmo_cromo/2)>1) {
        return 0;
    }
    
    return captura;

}



///funcao de escape para recuperar segundo gene pra aplicar uma translocacao
int recuperasegundogene(int rec,int newentrada[], int siz)
{
    //buscar o gene
    int cromi=0;
    int cromj=0;
    int t;
    for (t=0; t<siz; t++)
    {
        if (newentrada[t]==0)
            cromi++;
        if (t==rec)
            break;
        
    }
    
    for (t=0; t<siz; t++)
    {
        if (newentrada[t]==0) {
            
                cromj++;
        }
            if (abs(newentrada[rec]+1) == abs(newentrada[t])  || abs(newentrada[rec]-1) == abs(newentrada[t]) )
            {
                
                if (cromj!=cromi) {
                    break;
                }
                
            }
            
        }
    

    return t;

}

int d_tranlocation(int entrada[],int entrada2[], int siz){
    int cont_dist=0;
    int *improperAdjs=(int *) calloc (2* siz, sizeof (int));
    int cont_improper=0;
    int improper=0;
    int * newentrada=(int *) calloc (siz, sizeof (int));//quarda a nova entrada apos uma tranlocacao
    int * scndCut= (int *) calloc (2, sizeof (int));
    flag=-1;//marca a ultima posicao usada no newgenoma, aqui estamos apenas iniciando
    int allGenesInComps=0;
    int needAnotherPreStep=0;
    int t,i,j;
    int *adjNew=(int *) calloc (2 * qtd_genes + 1, sizeof (int));
    int * adjArray1=(int *) calloc (2 * qtd_genes + 1, sizeof (int));	
    int scndCase=0;//faz uso como variavel booleana
    int newTransDistance;
    int lastImpr = 2;
    identifyComponents( entrada,entrada2, siz,1);//carrega funcoes para calculo de indentificacao de componentes
    int *genomeCappedMinus= cappingM(entrada, siz);
    int *genomeCappedPlus= cappingP(entrada,siz);
    int nbegnes=qtd_genes;
    componente * COMPONENTS=compIdentificationPhase12(nbegnes,entrada, entrada2, siz);
    Conteiner* compTree= generateCompTree(entrada, entrada2, siz,genomeCappedMinus,genomeCappedPlus,COMPONENTS,1);
    int * geneInCompArray=generateGeneInCompArray( COMPONENTS, genomeCappedPlus, nbegnes);
    int *geneAtCompBorderArray= generateGeneAtCompBorderArray(COMPONENTS, genomeCappedPlus, nbegnes);
    int *posDepthArray=generatePosDepthArray(genomeCappedPlus, COMPONENTS,nbegnes);
    int * newChromMap=(int *) calloc ((qtd_genes + 2), sizeof (int));
    genNewChromMap( entrada,siz, newChromMap);
     int * compMap = (int *) calloc (CONT, sizeof (int));
     generateCompMap(newChromMap, COMPONENTS,CONT,genomeCappedPlus, compMap);
    int *savePlusCapped= (int *) calloc (TAMANHO_CAPPEPLUS, sizeof (int));       
    int *saveMinCapped=(int *) calloc (TAMANHO_CAPPEPLUS, sizeof (int));	
    //status indica se eh para o genoma A ou B
    int *adjG1= parseAdjacencies(1,  entrada,siz);
    int *adjG2=parseAdjacencies(2,  entrada2,siz);//load genoma B
    int  involvExtremities[4];
    int *visited=(int *) calloc (2 * qtd_genes + 1, sizeof (int));
      
            
    if (leaves%2==0 && Qtd_Tree==1)
        t= leaves+2;
    
    else if(leaves%2==1)
        t=leaves+1;
    else
        t=leaves;
    int distancia = qtd_genes - qtd_cromossomo - numberOfCycles + t;
    newTransDistance=distancia;
    listoperation * operationList = malloc ((distancia+2) * sizeof (listoperation));
    int contop=0;
    int dist_escrava=distancia;
    
    
   
    ////////////////////////////////////////
    // calcular leafToIndexMap-------------

    int * leafToIndexMap=getLeafToIndexMap(compTree, Qtd_Tree,  leaves);
    int *treeIndexMap=TreeIndexMap(compTree,Qtd_Tree,leaves);//mapeia folhas na arvore relacionando a componentes
    
    ///////////////////////////////////////////////////////////////////////////////////////////////////////
    //----------reduce the number of leaves/components to an even number or destroy last tree--------------
    ///////////////////////////////////////////////////////////////////////////////////////////////////////
    generateGenome(adjG1,2*qtd_genes+1);
    newentrada=reconstruirentrada(entrada,siz);

    if ((allGenesInComps && leaves%2==0 && Qtd_Tree==1) || (leaves%2==0 && Qtd_Tree==1) ||leaves%2==1) 
        needAnotherPreStep=1;
    
     operationList[contop].lista= (int *) calloc (siz, sizeof (int));		    
    for (i=0; i<siz; i++)
          operationList[contop].lista[i]=entrada[i];	
   while (needAnotherPreStep)
    {
        if (leaves % 2 == 0 && Qtd_Tree == 1)
        {
            //also means whole genome cannot be covered by components
                //destroy any leaf of the single tree such that L' = L-1 
               int iFirstLeaf = -1;
              //buscar a primeira folha da arvore
                for (i=0; i<compTree[0].size_tree; i++)
                {
                    if (compTree[0].arvore[i].isleaf)
                    {
                        iFirstLeaf=i;
                        break;
                    }
                }
                if (iFirstLeaf==-1 || compTree[0].arvore[iFirstLeaf].isleaf!=1)
                {
                    printf("Error in QTD_TREE==1\n");
                    break;
                }
                int start = compTree[0].arvore[iFirstLeaf].start;
                generateInvolvedExtremities( start, genomeCappedPlus,newChromMap,geneInCompArray,geneAtCompBorderArray,posDepthArray, newentrada, siz, involvExtremities);

                //save operations. Note that algos always have to store op in this order! result will be corrupted otherwise
		
                contop++;
                adjG1= assignInvolvedExtr( involvExtremities,adjG1, 1);
                operationList[contop].p1[0]=involvExtremities[0];
                operationList[contop].p1[1]=involvExtremities[3];
                operationList[contop].p2[0]=involvExtremities[1];
                operationList[contop].p2[1]=involvExtremities[2];
            //clonar a lista
	        
            operationList[contop].lista= (int *) calloc (siz, sizeof (int));
           
            

                ///////////////////////////////////////////////////////////////////////////////////////////////////////
                //----------------------- update all data structures after operation -----------------
                ///////////////////////////////////////////////////////////////////////////////////////////////////////
               
               
            generateGenome(adjG1,2*qtd_genes+1);
            newentrada=reconstruirentrada(newentrada,siz);
            for (i=0; i<siz; i++)
                 operationList[contop].lista[i]=newentrada[i];
            genNewChromMap( newentrada,siz,newChromMap);
            free(genomeCappedPlus);
            genomeCappedPlus= cappingP(newentrada,siz);
            free(genomeCappedMinus);
            genomeCappedMinus= cappingM(newentrada, siz);
            free(COMPONENTS);
            identifyComponents( newentrada,entrada2, siz,1);
            COMPONENTS=compIdentificationPhase12(nbegnes,newentrada, entrada2, siz);
            free(compTree);
            compTree= generateCompTree(newentrada, entrada2, siz,genomeCappedMinus,genomeCappedPlus,COMPONENTS,0);
             generateCompMap(newChromMap, COMPONENTS,CONT, genomeCappedPlus, compMap);
            leaves= numberLeaves(compTree, Qtd_Tree);
            free(leafToIndexMap);
            leafToIndexMap=getLeafToIndexMap(compTree, Qtd_Tree,  leaves);
            free(geneInCompArray);
            geneInCompArray=generateGeneInCompArray( COMPONENTS, genomeCappedPlus, nbegnes);
            free(geneAtCompBorderArray);
            geneAtCompBorderArray= generateGeneAtCompBorderArray(COMPONENTS, genomeCappedPlus, nbegnes);
     	    free(treeIndexMap);
            treeIndexMap= TreeIndexMap(compTree,Qtd_Tree,leaves);
            free(posDepthArray);
            posDepthArray=generatePosDepthArray(genomeCappedPlus, COMPONENTS,nbegnes);
            newTransDistance= calcTransDist(numberOfCycles, qtd_genes,  qtd_cromossomo,leaves, Qtd_Tree );
            dist_escrava=newTransDistance;
            cont_dist++;
        }//end of the first if
    
        if (leaves%2==1) 
        {
        
        	if(Qtd_Tree==1)
            {
                
                int iMiddleLeaf = leaves / 2;
                int iComp=-1;
                for (i=0; i<compTree[0].size_tree; i++)
                {
                    if (compTree[0].arvore[i].isleaf)
                    {
                        iComp++;
                        if ( iComp==iMiddleLeaf)
                            break;
                    }
                 }
                
                if (iComp==-1)
                {
                    printf("Error in QTD_TREE==1 \n");
                    break;
                }
                iComp=i;
                int start =compTree[0].arvore[iComp].start;
                generateInvolvedExtremities(start, genomeCappedPlus, newChromMap, geneInCompArray, geneAtCompBorderArray, posDepthArray, entrada,siz,involvExtremities);
                
            }//end if
            
          

            
      		 else
      		 {
    			//Searching by the tree with more childrens
        	        int maior=0;
        	 	for (i=0; i<Qtd_Tree; i++)
        	        {
        	                if(compTree[i].size_tree>  compTree[maior].size_tree)
        	                      maior=i;

        	        }//end for
                 
        	       ///////////////////////////////////////////////
        	       //----- fim busca maior------------------------
        	         
                        //searching for one of the largest tree leaf
                 int pare=0;
                 for (i=0; i<Qtd_Tree; i++)
                 {
                     for (j=0; j<compTree[i].size_tree; j++)
                     {
                         if (compTree[i].arvore[j].isleaf)
                         {
                             pare=1;
                             break;
                         }
                         
                     }
                     if (pare) {
                         break;
                     }
                     
                 }//end for
                 
                 int Start= compTree[i].arvore[j].start;
                 
                   if(Start > TAMANHO_CAPPEPLUS || Start<0)
                    {    printf("There Was a Fatal Error When picking up a Component to Destroy\n");
                               break;
                    }//end if
                    
               generateInvolvedExtremities(Start, genomeCappedPlus, newChromMap, geneInCompArray, geneAtCompBorderArray, posDepthArray, entrada,siz,involvExtremities);
              
      		 }//end else

             //------------------------------save operations---------------------------------------
           
            //adj tem tamanho (2 * qtd_genes + 1)
            
            
	        contop++;
            
            adjG1= assignInvolvedExtr( involvExtremities,adjG1, 1);
            operationList[contop].p1[0]=involvExtremities[0];
            operationList[contop].p1[1]=involvExtremities[3];
            operationList[contop].p2[0]=involvExtremities[1];
            operationList[contop].p2[1]=involvExtremities[2];
            //clonar a lista
            operationList[contop].lista= (int *) calloc (siz, sizeof (int));
            
            ///////////////////////////////////////////////////////////////////////////////////////////////////////
            //----------------------- update all data structures after operation -----------------
            ///////////////////////////////////////////////////////////////////////////////////////////////////////
           
            generateGenome(adjG1,2*qtd_genes+1);
            newentrada=reconstruirentrada(newentrada,siz);
	       for (i=0; i<siz; i++)
                operationList[contop].lista[i]=newentrada[i];
            //atualizando entrada pra nao comprometer a ideia aplicada aos outros arquivos
            genNewChromMap( newentrada,siz,newChromMap);// atualizando newChromMap (validado)
            free(genomeCappedPlus);//liberando espaco pra alocar abaixo
            genomeCappedPlus= cappingP(newentrada,siz);//atualizando
            free(genomeCappedMinus);
            genomeCappedMinus= cappingM(newentrada, siz);
            free(COMPONENTS);
            identifyComponents( newentrada,entrada2, siz,1);//carrega funcoes para calculo de indentificacao de componentes
            COMPONENTS=compIdentificationPhase12(nbegnes,newentrada, entrada2, siz);// validado, esta ok
            free(compTree);
            compTree= generateCompTree(newentrada, entrada2, siz,genomeCappedMinus,genomeCappedPlus,COMPONENTS,0);//validado
            generateCompMap(newChromMap, COMPONENTS,CONT, genomeCappedPlus, compMap);
            leaves= numberLeaves(compTree, Qtd_Tree);
            free(leafToIndexMap);
            leafToIndexMap=getLeafToIndexMap(compTree, Qtd_Tree,  leaves);
            free(geneInCompArray);
            geneInCompArray=generateGeneInCompArray( COMPONENTS, genomeCappedPlus, nbegnes);//validado
            free(geneAtCompBorderArray);
            geneAtCompBorderArray= generateGeneAtCompBorderArray(COMPONENTS, genomeCappedPlus, nbegnes);
            free(posDepthArray);
	        posDepthArray=generatePosDepthArray(genomeCappedPlus, COMPONENTS,nbegnes);
            free(treeIndexMap);
            treeIndexMap= TreeIndexMap(compTree,Qtd_Tree,leaves);
            newTransDistance= calcTransDist(numberOfCycles, qtd_genes,  qtd_cromossomo,leaves, Qtd_Tree );
            dist_escrava=newTransDistance;  
            cont_dist++;
     	}//end if leaves impar

        needAnotherPreStep = allGenesInComps;//allGenesInComps eh global
        
        if (leaves==1 && Qtd_Tree==1) {
            needAnotherPreStep=1;
        }
       
    }//end while
    

    
    
    ///////////////////////////////////////////////////////////////////////////////////////////////////////
    //while the genome is not sorted apply cases of "lemma 4/12", first components on different chromosomes
    ///////////////////////////////////////////////////////////////////////////////////////////////////////
    int start;	
    int genomeSorted = 0;
    int xi=0;
    int contapassada=0;//
    
    while (!genomeSorted) 
   {   xi++;
       int compsOnDiffChroms = 0;
        scndCase = 0;
        if (CONT > 0)
        {
            compsOnDiffChroms = testCompsOnDiffChroms(compMap, CONT, COMPONENTS,CONT);
        }
    
      if (compsOnDiffChroms)
       { //there exist intrachromosomal components on different chromosomes then
            //perform a bad translocation such that T' = 0, or T' > 1 and L' is even (Lemma 4)
            /*
             * 2 Cases: T has > 1 or = 1 leaf. If T has 1 leaf T2 also has 1 leaf & both can be destroyed
             * In 1st case choose second leaf from the left of biggest tree and pair it with any leaf of t2.
             * In 2nd case choose first leaf of each tree (there is only 1)
             * if theres the possibility that the operation doesnt fit anyway then add index saying which
             * adjacencies of the comps have already been tested when testing next operation
             */
           
           
            int nodeIBigTree=0;
             for (i=0; i<Qtd_Tree; i++)
             {
                if(compTree[i].size_tree > compTree[nodeIBigTree].size_tree)
                     nodeIBigTree=i;
            
             }//end for
            
            //localizando o cromossomo
            int chromNbBiggest = compMap[nodeToCompMap[nodeIBigTree]];
            //pegando a segunda maior arvore q esteja em um cromossomo diferente
		
            int node2ndBig;
		
            if(nodeIBigTree==0)
                 node2ndBig = 1;
            else
                  node2ndBig=0;
            
            int child2ndBiggest = -1;
            		
            for (i=0; i<Qtd_Tree; i++)
            {
                    if((compTree[i].size_tree >= compTree[node2ndBig].size_tree) && i!=nodeIBigTree )
                    {
                           for (j=0; j<compTree[i].size_tree; j++)
                            {
                                if (compTree[i].arvore[j].isleaf)
                                { 
                                     
                                    if (verifica_crhom(compTree[i].arvore[j].start, newentrada , siz)!=chromNbBiggest) {
                                               node2ndBig=i;
                                    }
                              
                                }//end if
                                
                            }//end for
                            
                          
                    }//end if
                
            }//end for

            child2ndBiggest=compTree[node2ndBig].size_tree-1;// -1 pois o primeiro no eh a raiz
            //get second or first leaf belonging to biggest tree
            int i2ndLeaf = 0;
            //look if there is a second largest leaf on the largest tree
            i=0;
           for (j=0; j<compTree[nodeIBigTree].size_tree; j++)
           {
               if (compTree[nodeIBigTree].arvore[j].isleaf)
               {
                   i++;
                   i2ndLeaf=j;
                   if (i==2)
                       break;
               }//end if
               
           }//end for
           if (compTree[nodeIBigTree].arvore[i2ndLeaf].isleaf==1)
           {
               start = compTree[nodeIBigTree].arvore[i2ndLeaf].start;
           }
           else
           {
               printf("Alert There is an Error in Structure Tree\n");
               break;
           }
           involvExtremities[0] = getExtremity1(genomeCappedPlus[start] * 2, 1);
           involvExtremities[1] = getExtremity1(genomeCappedPlus[start + 1] * 2, 0);
         
            //pegar a primeira folha da segunda grande arvore

           for (j=0; j<compTree[node2ndBig].size_tree; j++)
           {
           if (compTree[node2ndBig].arvore[j].isleaf)
           { 
                 break;
           }//end if
                                
           }//end for
                            
                    
	
            if (compTree[node2ndBig].arvore[j].isleaf==1) {
                start=compTree[node2ndBig].arvore[j].start;
            }
            else
            {
                printf("Alert There is an Error in Structure Tree\n");
                break;
            }
            involvExtremities[2] = getExtremity1(genomeCappedPlus[start] * 2, 1);
            involvExtremities[3] = getExtremity1(genomeCappedPlus[start + 1] * 2, 0);
        
         //update data structures-------------------------------------------------------------------------------
            
            for (i=0; i<2 * qtd_genes + 1; i++) {
                adjNew[i]=adjG1[i];
            }
            adjNew= assignInvolvedExtr( involvExtremities,adjNew, 1);
            generateGenome(adjNew,2*qtd_genes+1);
            newentrada=reconstruirentrada(newentrada,siz);
           
	    int chromNb = 1;
        for (i = 0; i < qtd_cromossomo; ++i)
        { 
         	newChromMap[i]=0;	
        }
        int *a= status_A(entrada,siz);
        for (i = 1; i < qtd_cromossomo; ++i)
        {  
            for (j = 0; j < a[i]; ++j)
            {   
                int geneL = GENOMA_A[i][j];
                newChromMap[abs(geneL)] = chromNb;
            }
            ++chromNb;
        }//end for 
     
             
        genomeCappedPlus= cappingP(newentrada,siz);
        free(genomeCappedMinus);
        genomeCappedMinus= cappingM(newentrada, siz);
        free(COMPONENTS);
        identifyComponents( newentrada,entrada2, siz,1);
        COMPONENTS=compIdentificationPhase12(nbegnes,newentrada, entrada2, siz);
        free(compTree);
        compTree= generateCompTree(newentrada, entrada2, siz,genomeCappedMinus,genomeCappedPlus,COMPONENTS,0);
        newTransDistance= calcTransDist(numberOfCycles, qtd_genes,  qtd_cromossomo,leaves, Qtd_Tree );
           

	}//end if
        
       
        ///////////////////////////////////////////////////////////////////////////////////////////////////////
        //--------------in case all components are located on the same chromosome, separate them---------------
        ///////////////////////////////////////////////////////////////////////////////////////////////////////
        else if(!compsOnDiffChroms && checkCompLength(COMPONENTS,CONT))
        {
        
            clona_genoma();//savegenome
            savePlusCapped=SavePlusCapped(genomeCappedPlus,savePlusCapped);//validado
            saveMinCapped=SaveMinCapped(genomeCappedMinus,saveMinCapped);
	
            int size2=leaves;
            int chromCheck = 1; //true if both genes are on same chrom, false otherwise
            
            int scndIndex = 0;
            
            treeIndexMap= TreeIndexMap(compTree,Qtd_Tree,leaves);
     	
            i=0;
            j=0;
	    
            while (chromCheck==1 && i < size2 - 1)
            { //retrieve first cut. loop for walking between all comps on the chrom
	       
        
                int endFstNode = COMPONENTS[nodeToCompMap[treeIndexMap[i]]].endIndex;
                int endSmallerScndNode = COMPONENTS[nodeToCompMap[treeIndexMap[i + 1] - 1]].endIndex;
                 int start = 0;
                if (endFstNode < endSmallerScndNode)
                {
                    //last comp before start of next tree is the interesting one, therefore endindex is directly obtained
                    start = endSmallerScndNode;
                }
                else
                {
                    start = endFstNode;
                }
                
                int scndComp = nodeToCompMap[getFstLeafOfTree(treeIndexMap[i + 1], leafToIndexMap,leaves)];
                int end = COMPONENTS[scndComp].startIndex;
                involvExtremities[0] = getExtremity1(genomeCappedPlus[start] * 2, 1);
                involvExtremities[1] = getExtremity1(genomeCappedPlus[start + 1] * 2, 0);
                scndIndex = start;
                if (improper)
                {
                    int isImproper = 1;
                    while (isImproper)
                    {
                        ++scndIndex;
                        isImproper=checkImproper(getExtremity1(genomeCappedPlus[scndIndex] * 2, 1), involvExtremities[2],adjG1,improperAdjs,cont_improper);
                       
                    }//end while
                    
                    involvExtremities[0] = getExtremity1(genomeCappedPlus[scndIndex] * 2, 1);
                    involvExtremities[1] = getExtremity1(genomeCappedPlus[scndIndex + 1] * 2, 0);
                }
               
                while (chromCheck == ChromCheck(genomeCappedPlus, newChromMap, scndIndex, qtd_genes) && scndIndex < end)
                {
                    ++scndIndex;
                    involvExtremities[0] = getExtremity1(genomeCappedPlus[scndIndex] * 2, 1);
                    involvExtremities[1] = getExtremity1(genomeCappedPlus[scndIndex + 1] * 2, 0);
                }
                ++i;
		                
                
            }//end while start
            
            scndCut = genScndCut(genomeCappedPlus,scndCut);
            involvExtremities[2] = scndCut[0];
            involvExtremities[3] = scndCut[1];
            improper = 0;
            lastImpr = involvExtremities[0];
            int scnd = 0;
      
      while (++scnd <= 2)
      { //TODO: Check unneccessary because of scnd cut generator?
          
                adjArray1 = clonar_adjG1( adjArray1,adjG1, 2*qtd_genes+1);
           
                  if (scnd == 1)
                  {   
                        adjArray1 = assignInvolvedExtr(involvExtremities, adjArray1, 1);
                    }
                    else
                    { 
                        adjArray1 = assignInvolvedExtr(involvExtremities, adjArray1, 0);
                    }
                   
          
                    //generate new genomeA and Adjacency graph
                      
                    generateGenome(adjArray1,2*qtd_genes+1);
                    newentrada=reconstruirentrada(newentrada,siz);
     
       		   
                    free(COMPONENTS);
                    identifyComponents( newentrada,entrada2, siz,1);
                    COMPONENTS=compIdentificationPhase12(nbegnes,newentrada, entrada2, siz);
    
    
		        if (checkCompLength(COMPONENTS,CONT))
		        {
			
                    free(genomeCappedPlus);
                    genomeCappedPlus= cappingP(newentrada,siz);//atualizando
                    free(genomeCappedMinus);
                    genomeCappedMinus= cappingM(newentrada, siz);
                    free(compTree);
                    compTree= generateCompTree(newentrada, entrada2, siz,genomeCappedMinus,genomeCappedPlus,COMPONENTS,0);
			        newTransDistance= calcTransDist(numberOfCycles, qtd_genes,  qtd_cromossomo,leaves, Qtd_Tree );
                    
                   

                          if (newTransDistance < dist_escrava)
                          {
                            if (scnd == 2) 
                            {
                                scndCase = 1;
                            }
                            improper = 0;
                            ++scnd;
                            lastImpr = 2;
                          } 
		          
                          else if (scnd == 2)
                          {
			   
                              improperAdjs[cont_improper]=involvExtremities[0];
                              cont_improper++;
                              improperAdjs[cont_improper]=involvExtremities[1];
                              cont_improper++;
                              improperAdjs[cont_improper]=involvExtremities[2];
                              cont_improper++;
                              improperAdjs[cont_improper]=involvExtremities[3];
                              cont_improper++;
                              improper = 1;
                              genomeCappedPlus =recoveryPlusCapped( savePlusCapped, genomeCappedPlus, TAMANHO_CAPPEPLUS);
                              genomeCappedMinus= recoveryMinCapped(saveMinCapped, genomeCappedMinus, TAMANHO_CAPPEPLUS);
                              rec_genoma();
                              newentrada=reconstruirentrada(newentrada,siz);
                              free(COMPONENTS);
                              identifyComponents( newentrada,entrada2, siz,1);
                              COMPONENTS=compIdentificationPhase12(nbegnes,newentrada, entrada2, siz);
                              free(compTree);
                              compTree= generateCompTree(newentrada, entrada2, siz,genomeCappedMinus,genomeCappedPlus,COMPONENTS,0);
                          }//end else if
			
                  }//end if
		  
                else if (scnd == 2)
                {
                    improperAdjs[cont_improper]=involvExtremities[0];
                    cont_improper++;
                    improperAdjs[cont_improper]=involvExtremities[1];
                    cont_improper++;
                    improperAdjs[cont_improper]=involvExtremities[2];
                    cont_improper++;
                    improperAdjs[cont_improper]=involvExtremities[3];
                    cont_improper++;
                    improper = 1;
                    genomeCappedPlus =recoveryPlusCapped( savePlusCapped, genomeCappedPlus, TAMANHO_CAPPEPLUS);
                    genomeCappedMinus= recoveryMinCapped(saveMinCapped, genomeCappedMinus, TAMANHO_CAPPEPLUS);
                    rec_genoma();
                    newentrada=reconstruirentrada(newentrada,siz);
                    free(COMPONENTS);
                    identifyComponents( newentrada,entrada2, siz,1);
                    COMPONENTS=compIdentificationPhase12(nbegnes,newentrada, entrada2, siz);
                    free(compTree);
                    compTree= generateCompTree(newentrada, entrada2, siz,genomeCappedMinus,genomeCappedPlus,COMPONENTS,0);
                }//end else
		    
            
           }//end while
            
        
     }//end else if

		   
     else 
      {
                /*
                 * Standard case of performing a proper translocation sorting the genome.
                 * proper, if for prefix-prefix translocation there's a cycle (uv...fg..u) and for
                 * prefix-suffix trans (with gene inversion) there's a cycle (uv...gf..u) in Adjacency graph.
                 */
          
          
            int ex = adjG1[lastImpr];
            int startEx = lastImpr;
            int chromNbStart = newChromMap[(ex + 1) / 2];
            int chromNb = newChromMap[(startEx + 1) / 2];
          
            if (!improper)
            {
                int t;
                for(t=0;t <2 * qtd_genes + 1;t++ )
                    visited[t]=0;
            }
          
            visited[startEx] = 1;
            visited[ex] = 1;
            int fstGenome = 0;
          
            while (chromNbStart == chromNb || (chromNbStart != chromNb && !fstGenome))
           {
               contapassada++;
               
               
               if (contapassada==400) {
                   break;
               
               }
              
               
		       if (fstGenome)
                {
                    
                    ex = adjG1[ex];
                    chromNb = newChromMap[(ex + 1) / 2];
                    fstGenome = 0;
                    
                   
                }
               
		        else
                 {
                     
                       ex = adjG2[ex];
                       chromNb = newChromMap[(ex + 1) / 2];
                        fstGenome = 1;
                     
                     
                 }
                    visited[ex] = 1;
               
               
                    if (startEx == ex )
                    {
                        
                        while (visited[startEx])
                        {
                            ++startEx;
                            chromNbStart = newChromMap[(startEx + 1) / 2];
                            chromNb = newChromMap[(startEx + 1) / 2];
                            ex = startEx;
                    
                       }//end while
                        
                        visited[ex] = 1;
                        fstGenome = 0;
                    }//end if
               
    
                    if (improper) 
                    {
                        
                        
                        while (checkImproper( ex, startEx, adjG1, improperAdjs, cont_improper)) 
                        {
                            
                            int oldEx = ex;
                            int fst = 1;
                            while (ex != oldEx || fst)
                            {
                                if (fstGenome)
                                {
                                    visited[ex] = 0;
                                    ex = adjG1[ex];
                                    fstGenome = 0;
                                }
                               else 
                                {
                                    visited[ex] = 0;
                                    ex = adjG2[ex];
                                    fstGenome = 1;
                                }
                                fst = 0;
                            }//end while
                            
                            ++startEx;
                            ex = startEx;
                            chromNbStart = newChromMap[(startEx + 1) / 2];
                            chromNb = newChromMap[(startEx + 1) / 2];
                            
                            
                        }//end while externo
                        
                    }//end if
              
               }//end while
          
          
         
          improper = 0;
          involvExtremities[0] =startEx;
          involvExtremities[1] =adjG1[startEx];
          involvExtremities[2] =ex;
          involvExtremities[3] = adjG1[ex];

          
          if (contapassada==400)
          {
              int rec=unica_translocacao(newentrada, siz);
              int rec2=-1;
              if (rec!=0)
              {
                  rec2=recuperasegundogene(rec,newentrada, siz);
                  if (rec2==0 || rec2== siz-1 || newentrada[rec2+1]==0 ||newentrada[rec2-1]==0) {
                      printf("\n*************ERROR In Only Translocation**************\n");
                       break;
                  
                  }
                  
                  involvExtremities[0]=0;
                  involvExtremities[1]=0;
                  involvExtremities[2]=0;
                  involvExtremities[3]=0;
                  if (newentrada[rec]<newentrada[rec2]) {
                      if (newentrada[rec]<0) {
                          involvExtremities[0] = 2*abs(newentrada[rec])-1;//startEx;
                      }
                      
                      if (newentrada[rec+1]>0) {
                          involvExtremities[1] =2*abs(newentrada[rec+1])-1;// adjG1[startEx];
                      }
                      
                      
                      if (newentrada[rec2-1]>0) {
                          involvExtremities[2] = 2*abs(newentrada[rec2-1]);
                      }
                      
                      if (newentrada[rec2]<0) {
                          involvExtremities[3] = 2*abs(newentrada[rec2]);//adjG1[ex];
                      }
                      
                  }
                  
                  
                  if (involvExtremities[0]==0 ||involvExtremities[1]==0 ||involvExtremities[2]==0 || involvExtremities[3]==0) {
                      printf("\n*************Error Report to The Implementer**************\n");
                       break;
                  
                  }
                                    
              }
              
             
              
          }
                    
          
          
          if (involvExtremities[0]==involvExtremities[2] || involvExtremities[1]==involvExtremities[3]) {
              printf("Report To The Implementer ***********\n");
              break;
             
          }
          
          
                lastImpr = startEx;
          
                    
               int scnd = 0;
                clona_genoma();//savegenome
                savePlusCapped=SavePlusCapped(genomeCappedPlus,savePlusCapped);
                saveMinCapped=SaveMinCapped(genomeCappedMinus,saveMinCapped);
          
                while (++scnd <= 2)
                {    
                     adjArray1 = clonar_adjG1( adjArray1,adjG1, 2*qtd_genes+1);
                     
                    if (scnd == 1)
                    {
			            adjArray1 = assignInvolvedExtr(involvExtremities, adjArray1, 1);
                        
                        
                    } 
                   else
                    {
                        adjArray1 = assignInvolvedExtr(involvExtremities, adjArray1, 0);
                       
                        
                        
                    }
	            
                    generateGenome(adjArray1,2*qtd_genes+1);
                    newentrada=reconstruirentrada(newentrada,siz);
                    free(COMPONENTS);
                    identifyComponents( newentrada,entrada2, siz,1);
                    COMPONENTS=compIdentificationPhase12(nbegnes,newentrada, entrada2, siz);
                    
                     if (!checkCompLength(COMPONENTS,CONT)) 
                    {
                        
                          free(genomeCappedPlus);
                          genomeCappedPlus= cappingP(newentrada,siz);
                          free(genomeCappedMinus);
                          genomeCappedMinus= cappingM(newentrada, siz);
                            if (Qtd_Tree!=0)
                                free(compTree);
                        
                          compTree= generateCompTree(newentrada, entrada2, siz,genomeCappedMinus,genomeCappedPlus,COMPONENTS,0);
                          newTransDistance= calcTransDist(numberOfCycles, qtd_genes,  qtd_cromossomo,leaves, Qtd_Tree );//numberOfCycles is global
                        
                        if (newTransDistance < dist_escrava)
                        { contapassada=0;
                            
                            if (scnd == 2)
                            {
                                scndCase = 1;
                            }
                            improper = 0;
                            ++scnd;
                            lastImpr = 2;
                            
                        }
                      else if (scnd == 2) 
                      {
                             improperAdjs[cont_improper]=involvExtremities[0];
                             cont_improper++;
                  	         improperAdjs[cont_improper]=involvExtremities[1];
                             cont_improper++;
                             improperAdjs[cont_improper]=involvExtremities[2];
                             cont_improper++;
                             improperAdjs[cont_improper]=involvExtremities[3];
                             cont_improper++;
                             improper = 1;
                              genomeCappedPlus =recoveryPlusCapped( savePlusCapped, genomeCappedPlus, TAMANHO_CAPPEPLUS);
        		              genomeCappedMinus= recoveryMinCapped(saveMinCapped, genomeCappedMinus, TAMANHO_CAPPEPLUS);
                              rec_genoma();
                              newentrada=reconstruirentrada(newentrada,siz);
                              free(COMPONENTS);
	                          identifyComponents( newentrada,entrada2, siz,1);
                              COMPONENTS=compIdentificationPhase12(nbegnes,newentrada, entrada2, siz);
                               free(compTree);
	                          compTree= generateCompTree(newentrada, entrada2, siz,genomeCappedMinus,genomeCappedPlus,COMPONENTS,0);	
                      }
                    }//end if
                   else if (scnd == 2) 
                   {
                       improperAdjs[cont_improper]=involvExtremities[0];
                       cont_improper++;
                       improperAdjs[cont_improper]=involvExtremities[1];
                       cont_improper++;
                       improperAdjs[cont_improper]=involvExtremities[2];
                       cont_improper++;
                       improperAdjs[cont_improper]=involvExtremities[3];
                       cont_improper++;
                       improper = 1;
                       genomeCappedPlus =recoveryPlusCapped( savePlusCapped, genomeCappedPlus, TAMANHO_CAPPEPLUS);
                       genomeCappedMinus= recoveryMinCapped(saveMinCapped, genomeCappedMinus, TAMANHO_CAPPEPLUS);
                       rec_genoma();
                       newentrada=reconstruirentrada(newentrada,siz);
                       free(COMPONENTS);
                       identifyComponents( newentrada,entrada2, siz,1);
                       COMPONENTS=compIdentificationPhase12(nbegnes,newentrada, entrada2, siz);
                       free(compTree);
                       compTree= generateCompTree(newentrada, entrada2, siz,genomeCappedMinus,genomeCappedPlus,COMPONENTS,0);
                       
                   }//end else if
		
                }//end while
          
            }//end else
       
      
    //-----------------------------save operations------------------------------------------------------------
	if (!improper && newTransDistance < dist_escrava)
    {           
           cont_improper=0;
           contop++;
            if (scndCase) 
	       {  
               
               adjG1= assignInvolvedExtr( involvExtremities,adjG1, 0);
              				
               operationList[contop].p1[0]=involvExtremities[0];
               operationList[contop].p1[1]=involvExtremities[2];
               operationList[contop].p2[0]=involvExtremities[1];
               operationList[contop].p2[1]=involvExtremities[3];	
	
           } 
            else
          {
               
                adjG1= assignInvolvedExtr( involvExtremities,adjG1, 1);
                operationList[contop].p1[0]=involvExtremities[0];
                operationList[contop].p1[1]=involvExtremities[3];
                operationList[contop].p2[0]=involvExtremities[1];
                operationList[contop].p2[1]=involvExtremities[2];	
              
           }
         
        
        
            genNewChromMap( newentrada,siz, newChromMap);

            generateCompMap(newChromMap, COMPONENTS,CONT,genomeCappedPlus, compMap);
       
            leaves= numberLeaves(compTree, Qtd_Tree);
	       free(leafToIndexMap);
            leafToIndexMap=getLeafToIndexMap(compTree, Qtd_Tree,  leaves);
		
            free(treeIndexMap);
            treeIndexMap= TreeIndexMap(compTree,Qtd_Tree,leaves);
	    
            operationList[contop].lista= (int *) calloc (siz, sizeof (int));
             for (i=0; i<siz; i++)
             {
                 operationList[contop].lista[i]=newentrada[i];
             }
            dist_escrava=newTransDistance;	
        
        
           if (dist_escrava == 0) {
               genomeSorted = 1;
           }
	
       }//end if save operations         
       
	         
       cont_dist++;
     
 
       
    }//end while 
   
printf("\n**************Show Translocations **********\n");

for(i=0;i<=contop;i++)
{
    printf("%d:",i);
    for(j=0;j<siz;j++)
      {     if(j==0)
	     printf("(%d,",operationList[i].lista[j]);
 	   else if(j+1==siz)
	    printf("%d)",operationList[i].lista[j]);
            else if(operationList[i].lista[j]==0)
		printf(") (");
	   else if(operationList[i].lista[j+1]==0)
		printf("%d",operationList[i].lista[j]);	
           else
		printf("%d,",operationList[i].lista[j]);
      }
	
printf("\n");
}
    
grava(operationList, contop, siz,newTransDistance);
return distancia; 
}//end d_tranlocation

void CompTreeGeneration(int entrada[],int entrada2[], int siz)
{
    d_tranlocation(entrada,entrada2, siz);
}// end compTreeGeneration

