
/*
 ============================================================================
 Project     : Distance Translocation Algorithm
 Author      : Lucas Angelo Silveira
 Universidade de Brasilia (UnB) - Brazil
 Group of Theory of Computation
 Version     : 1.0
 
 Last Modified On: May 09, 2015.
 ============================================================================
 */
 



#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>
#include "validate_input.h"

int qtd_cromossomo;//amount of chromosome
int qtd_genes;//amount of genes
int GENOMA_A[200][201];//It supports up to 200 chromosomes with 200 genes in each
int GENOMA_B[200][201];//It supports up to 200 chromosomes with 200 genes in each


//Check if genomes A and B are cotails
int is_cotail(int entrada[],int entrada2[],int size, int sizeB)
{
    int i=0;
   
   
    if (size !=sizeB) {
        return 0;
    }
    
    int conjuntoA[size];
    int conjuntoB[size];
    
    
    for (; i<size; i++) {
        
        conjuntoA[i]=0;
        conjuntoB[i]=0;
    }
    
    conjuntoA[abs(entrada[0])]=entrada[0];
    conjuntoB[abs(entrada2[0])]=entrada2[0];
    
    
    for (i=1; i<size; i++) {
        
            
        if(i+1 <size && entrada[i+1]==0 )
            conjuntoA[abs(entrada[i])]= -1* entrada[i];
        
        else  if(i+1==size)
            conjuntoA[abs(entrada[i])]=-1*entrada[i];
        
        else if(i>1 && entrada[i-1]==0)
            conjuntoA[abs(entrada[i])]=entrada[i];
        
        else
        {
            if (entrada[i]==0 && conjuntoA[i]==0) {
                conjuntoA[i]=0;
            }
            conjuntoA[abs(entrada[i])]=0;
        
        
        }
        
        
         if(i+1 <size && entrada2[i+1]==0 )
        {

            conjuntoB[abs(entrada2[i])]= -1* entrada2[i];
        
        
        }
        else if(i+1==size)
            conjuntoB[abs(entrada2[i])]=-1*entrada2[i];
        
       else if(i>1 && entrada2[i-1]==0)
            conjuntoB[abs(entrada2[i])]=entrada2[i];
        else
        {   if(entrada2[i]==0 && conjuntoB[i]==0)
                conjuntoB[i]=0;
            else
            conjuntoB[abs(entrada2[i])]=0;
        }
    }//fim do for
    
    
    
    
    for (i=0; i<size; i++) 
    {
        if(conjuntoA[i]!=conjuntoB[i])
            return 0;
    }
   i=0; 
   int conta_cromossomo=0;
    for (; i<size; i++) {
        
        if (entrada[i]==0) 
	    conta_cromossomo++;
          
    }//fim for
   
    conta_cromossomo++;
    qtd_cromossomo=conta_cromossomo;
    qtd_genes= (size-qtd_cromossomo)+1;
    
    return 1;
}//fim da funcao



//Contain the status of each crhomosome of genome A and end index where each chromosome start and end
int * status_A(int entrada[],int size){
    int i=0;
    int j=0;
    int *estatus2=(int *) calloc (qtd_cromossomo, sizeof (int));
     
    int conta_genes=0;
    int conta_cromossomo=0;
 
    for (; i<size; i++)
    {
        
        if (entrada[i]==0) {
            estatus2[j]=conta_genes;
            j++;
	    conta_cromossomo++;
            conta_genes=0;
        }
        
        else
        {
             conta_genes++;
        }
             
    }//end for
   
    estatus2[j]=conta_genes;
return estatus2;

}

//Contain the status of each crhomosome of genome B and end index where each chromosome start and end
int *status_B(int entrada2[],int sizeB)
{
   
    int i=0;
    int B=0;
    
    for (; i<sizeB; i++)
    {
        if(entrada2[i]==0)
            B++;
    }
    
    B++;
 
   int *estatus3=(int *) calloc (B, sizeof (int));
     i=0;
    int conta_genesB=0;
    int conta_cromossomoB=0;
    for (; i<sizeB; i++)
    {
        if (entrada2[i]==0)
        {
		
            estatus3[conta_cromossomoB]=conta_genesB;	
            conta_cromossomoB++;
            conta_genesB=0;
           
        }
        else
        {
             conta_genesB++;   
        }
        
        
    }//end for
   
    estatus3[conta_cromossomoB]=conta_genesB;
    
return  estatus3;

}//end function


//load genomes A and B
void load_genoma(int entrada[],int entrada2[],int size, int sizeB)
{
    int i=0;
    int conta_genes=0;
    int conta_genesB=0;
    int conta_cromossomo=0;
    int conta_cromossomoB=0;
    for (; i<size; i++)
    {
        
        if (entrada[i]==0)
        {
            GENOMA_A[conta_cromossomo][conta_genes]=0;	
            conta_cromossomo++;
            conta_genes=0;
        }
        
        else
        {
            GENOMA_A[conta_cromossomo][conta_genes]=entrada[i];
             conta_genes++;
        }
        
        if (entrada2[i]==0)
        {
            GENOMA_B[conta_cromossomoB][conta_genesB]=0;
            conta_cromossomoB++;
            conta_genesB=0;
        }
        else
        {
            GENOMA_B[conta_cromossomoB][conta_genesB]=entrada2[i];
            conta_genesB++;
        }
        
        
    }//end for
   
    GENOMA_B[conta_cromossomoB][conta_genesB]=0;
    GENOMA_A[conta_cromossomo][conta_genes]=0;
    
}//end function


